<template>
  <ChartWrapperVent :title="title" :subTitle="subTitle" :sideText="meaning.sideTexts" :titleMaxWidth="titleMaxWidth">
    <apexchart
      height="210"
      :options="chartOptions"
      :series="meaning.data.series"
    />
  </ChartWrapperVent>
</template>

<script>
import ChartWrapperVent from '@/components/Ventilation/ChartWrapperVent';

export default {
  name: 'VentilationDiagram',
  components: {
    ChartWrapperVent,
  },
  props: {
    title: {
      type: String,
      default: '',
    },
    subTitle: {
      type: String,
      default: '',
    },
    titleMaxWidth: {
      type: String,
      default: '60%',
    },
    themeMode: {
      type: String,
      default: 'light',
    },
    meaning: {
      type: Object,
      default: () => {
        return {
          sideTexts: [],
          data: {
            series: [],
            labels: []
          },
          total: [],
          colors: [],
        }
      }
    },
  },
  computed: {
    chartOptions() {
      return {
          chart: {
          type: 'bar',
          stacked: true,
          toolbar: {
            show: false
          },
        },
        colors: this.meaning.colors,
        plotOptions: {
          bar: {
            horizontal: false,
            borderRadius: 10
          },
        },
        legend: {
          show: false,
          position: 'right',
          offsetY: 40
        },
        fill: {
          opacity: 1
        },
        tooltip: {
          enabled: false,
        },
        dataLabels: {
          formatter: (val, opts) => {
            let index = opts.dataPointIndex;
            let total = this.meaning.data.total;
            let newVal;
            if (val !== 0) {
              newVal = val / total[index] * 100
            } else {
              newVal = val;
            }
            return newVal + '%'
          },
        },
        // plotOptions: {
        //   bar: {
        //     horizontal: false,
        //     borderRadius: 10
        //   },
        // },
        // fill: {
        //   opacity: 1
        // },
        // legend: { show: false },
      }
    }
  }
};
</script>
